"use strict";

function initUser(done) {
  function generateUserId() {
    const idLength = 16;
    const characters = 'abcdefghijklmnopqrstuvwxyz0123456789';
    let result = '';
    for (let i = 0; i < idLength; i++) {
      result += characters.charAt(Math.floor(Math.random() * characters.length));
    }
    return result;
  }

  function isNicknameValid(nickname) {
    return nickname.length < 30;
  }

  let storedUser = storage.getUser();
  if (storedUser) {
    done(storedUser);
    return;
  }

  while (true) {
    let nickname = window.prompt("Enter your nickname");
    if (nickname && isNicknameValid(nickname)) {
      let user = {
        nickname: nickname.trim(),
        userId: generateUserId()
      };
      storage.storeUser(user);
      done(user);
      return;
    }
  }
}
